public class Hi { // vier Typen innerer Klassen
  static String a = "A";
  private String b = "B";

  static class A { // geschachtelte Top-Level-Klasse A
    void hi () {
      System.err.println("top-level: " + a);
//    System.err.println(b); /* geht nicht: b ist nicht static! */
    }
  }
  class B { // Elementklasse B
    void hi () {
      System.err.print("member: " + a + b);
      System.err.println(Hi.this.a + Hi.this.b); // dies ist die explizite Form
    }
  }
  void hi (final String c) {
    final String d = "D";
    String e = "E";
    class C { // lokale Klasse C
      void hi () {
        System.err.println("lokal: " + a + b + c + d);
//      System.err.println(e); /* geht nicht: e ist nicht final! */
      }
    }
    Object o = new B() { // anonyme Klasse ist Subklasse von Klasse B
      { System.err.println("Instanzinitialisierer der anonymen Klasse"); }
      void hi () {
        System.err.println("anonym: " + a + b + c + d);
      }
    };
    new C().hi(); // fuehrt hi() der Klasse C aus
    ((B)o).hi();  // fuehrt hi() der anonymen Klasse aus
    new B().hi(); // fuehrt hi() der Klasse B aus
  }
  static public void main (String args []) {
    new Hi.A().hi();  // fuehrt hi() der Klasse A aus
    new Hi().hi("C"); // fuehrt die Top-Level-Methode hi("C") aus
  }
}
