// Aus: Ute Schmidt: InfB SS 2003
import java.util.Enumeration;
import java.util.NoSuchElementException;

public class ListEnumerator implements Enumeration
{
	protected int current = 0;
	protected MyList collection;
	
	public ListEnumerator(MyList c)
	{
		collection = c;
	}
	
	public boolean hasMoreElements() {
		return current < collection.numOfEls;
	}
	
	public Object nextElement() {
		if (!hasMoreElements())
			throw new NoSuchElementException();
		return collection.list[current++];
	}
	
	public static void main(String args[])
	{
		MyList stringList = new MyList();
		if (!stringList.add("erstens")) System.err.println("stringList voll");
		if (!stringList.add("zweitens")) System.err.println("stringList voll");
		if (!stringList.add("drittens")) System.err.println("stringList voll");
		
		ListEnumerator enum = new ListEnumerator(stringList);
		while (enum.hasMoreElements())
			System.out.println(enum.nextElement());
	}
}